<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:variable name="scriptlangs" select="/script"/>

<xsl:variable name="names"    select="/scripts/script/name"/>
<xsl:variable name="websites" select="/scripts/script/website"/>



<xsl:template match="/">
<html>
<head>
<title>Rosetta Stone for Scripting Languages</title>
<meta name="author" content="David Drysdale"/>
<script language="JavaScript" src="rosetta.js"></script>
</head>
<body onload="init()">

<h2>Rosetta Stone for Scripting Languages</h2>
<p>Inspired by the incredibly useful
<a href="http://bhami.com/rosetta.html">rosetta stone for
  UNIX sysadmins</a>.  Also, see the awesome
<a href="http://hyperpolyglot.org/">Hyperpolyglot</a> site.</p>

 <form name="scriptForm" method="post" action="">
 <table cellspacing="2" cellpadding="2" width="100%">
   <tr>
     <td rowspan="3" width="20%">
       <select id="ScriptChoiceBox" multiple="true" size="7">
        <xsl:for-each select="/scripts/script/name">
          <option><xsl:copy-of select="."/></option>
        </xsl:for-each>
       </select>
     </td>
      <td>
        <input type="button" name="setAlln" value="Set all" onClick="setAll()"/>
      </td>
      <td rowspan="3" width="60%">
        Use click, shift-click, control-click, and the "Set All" and
         "Clear All" buttons
        to select the desired subset of scripting languages. Then
        select "Draw table" to redraw the window with your custom table.
      </td>
    </tr>
    <tr>
      <td>
        <input type="button" name="clearAlln" value="Clear all" onClick="clearAll()"/>
      </td>
    </tr>
    <tr>
      <td>
        <input type="button" name="drawTable" value="Draw table" onClick="scanTable()"/>
      </td>
    </tr>
  </table>
  </form>
  <table frame="box" rules="all" id="RosettaTable">
    <tr nowrap="1">
      <th>Language</th>
      <xsl:for-each select="/scripts/script/name">
        <td nowrap="1"><b><xsl:copy-of select="."/></b></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Website</th>
      <xsl:for-each select="/scripts/script/website">
        <xsl:variable name="url" select="."/>
        <td nowrap="1"><a href="http://{$url}"><xsl:copy-of select="."/></a></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Author</th>
      <xsl:for-each select="/scripts/script/author">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>License</th>
      <xsl:for-each select="/scripts/script/license">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Single Line Invocation</th>
      <xsl:for-each select="/scripts/script/invocation">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Script File Invocation</th>
      <xsl:for-each select="/scripts/script/fileinvocation">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Whitespace</th>
      <xsl:for-each select="/scripts/script/whitespace">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Statement Separator</th>
      <xsl:for-each select="/scripts/script/statementseparator">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Block</th>
      <xsl:for-each select="/scripts/script/block">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Comment</th>
      <xsl:for-each select="/scripts/script/codecomment">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Variable</th>
      <xsl:for-each select="/scripts/script/variable">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Array</th>
      <xsl:for-each select="/scripts/script/array">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Array Size</th>
      <xsl:for-each select="/scripts/script/arraysize">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Hash</th>
      <xsl:for-each select="/scripts/script/hash">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Hash Iterate</th>
      <xsl:for-each select="/scripts/script/hashiterate">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>String</th>
      <xsl:for-each select="/scripts/script/string">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Command line arguments</th>
      <xsl:for-each select="/scripts/script/argv">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Last Result</th>
      <xsl:for-each select="/scripts/script/lastresult">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Assignment</th>
      <xsl:for-each select="/scripts/script/assignment">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Equality (string)</th>
      <xsl:for-each select="/scripts/script/equalsstring">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Equality (numeric)</th>
      <xsl:for-each select="/scripts/script/equalsnum">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Logical And</th>
      <xsl:for-each select="/scripts/script/andoperator">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Logical Or</th>
      <xsl:for-each select="/scripts/script/oroperator">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Logical Not</th>
      <xsl:for-each select="/scripts/script/notoperator">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Regexp Search</th>
      <xsl:for-each select="/scripts/script/regexpsearch">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Regexp Replace</th>
      <xsl:for-each select="/scripts/script/regexpreplace">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Conditional</th>
      <xsl:for-each select="/scripts/script/conditional">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Iteration</th>
      <xsl:for-each select="/scripts/script/forloop">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Loop</th>
      <xsl:for-each select="/scripts/script/whileloop">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Next Loop Iteration</th>
      <xsl:for-each select="/scripts/script/continue">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Exit Loop</th>
      <xsl:for-each select="/scripts/script/break">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Switch</th>
      <xsl:for-each select="/scripts/script/switch">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Function Definition</th>
      <xsl:for-each select="/scripts/script/fndefinition">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Function Call</th>
      <xsl:for-each select="/scripts/script/fnuse">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Function Parameters pass by</th>
      <xsl:for-each select="/scripts/script/fnpassby">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Print to stdout</th>
      <xsl:for-each select="/scripts/script/stdoutwrite">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Open File for Read</th>
      <xsl:for-each select="/scripts/script/fileopenread">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Open File for Write</th>
      <xsl:for-each select="/scripts/script/fileopenwrite">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Read from File</th>
      <xsl:for-each select="/scripts/script/fileread">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Write to File</th>
      <xsl:for-each select="/scripts/script/filewrite">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Close File</th>
      <xsl:for-each select="/scripts/script/fileclose">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Test File</th>
      <xsl:for-each select="/scripts/script/filetest">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Delete File</th>
      <xsl:for-each select="/scripts/script/filedel">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Rename File</th>
      <xsl:for-each select="/scripts/script/filerename">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>File Info</th>
      <xsl:for-each select="/scripts/script/fileinfo">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Output Formatting</th>
      <xsl:for-each select="/scripts/script/outputformatting">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>String Concatenation</th>
      <xsl:for-each select="/scripts/script/stringconcat">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>Substring</th>
      <xsl:for-each select="/scripts/script/stringsubstr">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>
    <tr nowrap="1">
      <th>String Tokenization</th>
      <xsl:for-each select="/scripts/script/stringtokenize">
        <td nowrap="1"><xsl:copy-of select="."/></td>
      </xsl:for-each>
    </tr>




    <tr nowrap="1">
      <th>Language</th>
      <xsl:for-each select="/scripts/script/name">
        <td nowrap="1"><b><xsl:copy-of select="."/></b></td>
      </xsl:for-each>
    </tr>
  </table>

  <p>Please let me know if you spot anything wrong or missing in the table.</p>

  <p>Helpful references used in the compilation of this table include:</p>
  <ul>
    <li><a href="http://www.amazon.com/exec/obidos/tg/detail/-/B00005R09V">"UNIX in a Nutshell (second edition)"</a>, Daniel Gilly et al, <a href="http://www.oreilly.com">O'Reilly</a> 1992</li>
    <li><a href="http://www.amazon.com/exec/obidos/tg/detail/-/B00005R09B/">"LINUX in a Nutshell"</a>, Jessica Perry Hekman et al, <a href="http://www.oreilly.com">O'Reilly</a> 1997</li>
    <li>"Programming Perl", Larry Wall &amp; Randal L. Schwartz, <a href="http://www.oreilly.com">O'Reilly</a> 1990 (<a href="http://www.amazon.com/exec/obidos/tg/detail/-/0596000278">current version</a>)</li>
    <li>"sed &amp; awk", Dale Dougherty, <a href="http://www.oreilly.com">O'Reilly</a> 1990 (<a href="http://www.amazon.com/exec/obidos/ASIN/1565922255">current version</a>)</li>
    <li>"Perl in a Nutshell", Ellen Siever, Stephen Spainhour &amp; Nathan Patwardhan, <a href="http://www.oreilly.com">O'Reilly</a> 1999 (<a href="http://www.amazon.com/exec/obidos/ASIN/0596002416">current version</a>)</li>
    <li><a href="http://www.amazon.com/exec/obidos/ASIN/0596001886">"Python in a Nutshell"</a>, Alex Martelli, <a href="http://www.oreilly.com">O'Reilly</a> 2003</li>
    <li><a href="http://www.amazon.com/exec/obidos/tg/detail/-/9997887492">"Tcl and the Tk Toolkit"</a>, John
    K. Ousterhout, <a href="http://www.aw-bc.com">Addison-Wesley</a> 1994</li>
    <li><a href="http://www.amazon.com/exec/obidos/tg/detail/-/0974514055">"Programming Ruby (2nd edn)"</a>, Dave Thomas, <a href="http://pragmatic.oreilly.com/">Pragmatic Bookshelf</a> 2005</li>
    <li><a href="http://www.amazon.com/exec/obidos/tg/detail/-/0596000480">"JavaScript: the Definitive Guide
    (4th edn)"</a>, David Flanagan, <a href="http://www.oreilly.com">O'Reilly</a> 2002</li>
    <li><a href="http://docs.python.org/howto/regex.html">Python Regular Expression HOWTO</a></li>
  </ul>
  <p>Thanks to:</p>
  <ul>
    <li>Ed Wilson</li>
    <li>Warren Falk</li>
    <li>Craig Spannring</li>
    <li>Brian Fennell</li>
    <li>Glenn Jackman</li>
    <li>Alan Oberlander</li>
  </ul>
  <p>Other links of interest:</p>
  <ul>
    <li><a href="http://merd.sourceforge.net/pixel/language-study/syntax-across-languages.html">Syntax across languages page</a></li>
    <li><a href="http://mike.dewolfe.bc.ca/rosettastone.asp">Rosetta Stone for Code</a></li>
  </ul>
  <p>This table is produced from a <a href="rosetta.tgz">collection of XML source files using an XSLT stylesheet</a>.</p>
<hr/>
<p><a href="http://www.lurklurk.org/">Back to Home Page</a></p>

<hr/>
<p><a href="mailto:dmd at_sign_here lurklurk dot_here org">Contact me</a></p>
<script src="http://www.google-analytics.com/urchin.js" type="text/javascript">
</script>
<script type="text/javascript">
_uacct = "UA-707535-2";
urchinTracker();
</script>
</body>
</html>
</xsl:template>

</xsl:stylesheet>
